#ifndef __RSPAM_H__
#define __RSPAM_H__

/* Where to store the config values */
#if EVOLUTION_VERSION < 30304
#define GCONF_KEY_ENABLE_DCC "/apps/evolution/rspam/use_dcc"
#define GCONF_KEY_ENABLE_RAZOR "/apps/evolution/rspam/use_razor2"
#define GCONF_KEY_ENABLE_SPAMCOP "/apps/evolution/rspam/use_spamcop"
#define GCONF_KEY_ENABLE_PYZOR "/apps/evolution/rspam/use_pyzor"
#define GCONF_KEY_RAZOR_HOME "/apps/evolution/rspam/razor_home"
#define GCONF_KEY_SPAMCOP_EMAIL "/apps/evolution/rspam/spamcop_email"
#define GCONF_KEY_MOVE_JUNK "/apps/evolution/rspam/move_junk"
#define GCONF_KEY_MOVE_FOLDER "/apps/evolution/rspam/move_folder"
#define GCONF_KEY_DRY_RUN "/apps/evolution/rspam/dry_run"
#else
#define CONF_SCHEMA "org.gnome.evolution.plugin.evolution-rspam"
#define CONF_KEY_ENABLE_DCC "use-dcc"
#define CONF_KEY_ENABLE_RAZOR "use-razor2"
#define CONF_KEY_ENABLE_SPAMCOP "use-spamcop"
#define CONF_KEY_ENABLE_PYZOR "use-pyzor"
#define CONF_KEY_RAZOR_HOME "razor-home"
#define CONF_KEY_SPAMCOP_EMAIL "spamcop-email"
#define CONF_KEY_MOVE_JUNK "move-junk"
#define CONF_KEY_MOVE_FOLDER "move-folder"
#define CONF_KEY_DRY_RUN "dry-run"
#endif

typedef struct _RSSEMailReaderClosure RSSEMailReaderClosure;

struct _RSSEMailReaderClosure {
	EMailReader *reader;
	EActivity *activity;
};


void rspam_finalize(void);

void mark_junk(gchar *uid, CamelFolder *folder);

void rspam_action_do (CamelFolder *folder,
#if EVOLUTION_VERSION >= 30101
			GAsyncResult *result,
			RSSEMailReaderClosure *closure);
#else
			const char *uid,
			CamelMimeMessage *msg,
			void *data);
#endif

guint read_ham(void);

guint read_spam(void);

gboolean check_discovery(void);

CamelStore *rspam_component_peek_local_store(void);

gchar *save_message(CamelMimeMessage *msg);

void update_stats(gboolean command);

gchar *pyzor_discover_cb (GtkWidget *widget, gpointer data);

gint rspam_command(CamelMimeMessage *msg, gchar *name,
		gint command);

GtkWidget *rspam_page_factory (EPlugin *ep,
		EConfigHookItemFactoryData *hook_data);

#endif /* __RSPAM_H__ */


